# coding: utf-8

"""
    BIMData API

    BIMData API documentation  # noqa: E501

    OpenAPI spec version: v1
    Contact: contact@bimdata.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from bimdata_api_client.api_client import ApiClient


class ProjectApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_classification(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_classification  # noqa: E501

                 Bulk create available.         You can either post an object or a list of objects.         Is you post a list, the response will be a list (in the same order) of created objects or of errors if any         If at least one create succeeded, the status code will be 201. If every create failed, the status code we'll be 400 with the list of errors          If created classification already exists, it will not be duplicated and the previous one will be returned.     You also can add a 'classification' filter on this endpoint. By ex: /classification?name='untec'. The name is case sensitive       # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_classification(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param list[Classification] data: (required)
        :return: list[Classification]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_classification_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.create_classification_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def create_classification_with_http_info(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_classification  # noqa: E501

                 Bulk create available.         You can either post an object or a list of objects.         Is you post a list, the response will be a list (in the same order) of created objects or of errors if any         If at least one create succeeded, the status code will be 201. If every create failed, the status code we'll be 400 with the list of errors          If created classification already exists, it will not be duplicated and the previous one will be returned.     You also can add a 'classification' filter on this endpoint. By ex: /classification?name='untec'. The name is case sensitive       # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_classification_with_http_info(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param list[Classification] data: (required)
        :return: list[Classification]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_classification" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `create_classification`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `create_classification`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `create_classification`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Classification]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_document(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_document(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_document_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.create_document_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def create_document_with_http_info(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_document_with_http_info(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `create_document`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `create_document`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `create_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Document',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_folder(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_folder(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_folder_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.create_folder_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def create_folder_with_http_info(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_folder_with_http_info(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_folder" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `create_folder`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `create_folder`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `create_folder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Folder',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_project(self, cloud_pk, data, **kwargs):  # noqa: E501
        """create_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_project(cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_project_with_http_info(cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.create_project_with_http_info(cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def create_project_with_http_info(self, cloud_pk, data, **kwargs):  # noqa: E501
        """create_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_project_with_http_info(cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `create_project`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `create_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Project',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_project_user(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_project_user(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.create_project_user_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.create_project_user_with_http_info(project_pk, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def create_project_user_with_http_info(self, project_pk, cloud_pk, data, **kwargs):  # noqa: E501
        """create_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.create_project_user_with_http_info(project_pk, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_project_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `create_project_user`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `create_project_user`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `create_project_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FosUserWrite',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_classification(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_classification(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_classification_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_classification_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def delete_classification_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_classification_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_classification" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `delete_classification`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `delete_classification`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `delete_classification`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_document(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_document(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_document_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_document_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def delete_document_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_document_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `delete_document`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `delete_document`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `delete_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_folder(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_folder(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_folder_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_folder_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def delete_folder_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_folder_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_folder" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `delete_folder`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `delete_folder`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `delete_folder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_project(self, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_project(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_project_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_project_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def delete_project_with_http_info(self, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_project_with_http_info(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `delete_project`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `delete_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_project_user(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_project_user(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.delete_project_user_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_project_user_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def delete_project_user_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """delete_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.delete_project_user_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_project_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `delete_project_user`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `delete_project_user`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `delete_project_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user/{id}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_classification(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_classification(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Classification data: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.full_update_classification_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_classification_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def full_update_classification_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_classification_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Classification data: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_classification" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `full_update_classification`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_classification`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `full_update_classification`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `full_update_classification`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Classification',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_document(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_document(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.full_update_document_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_document_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def full_update_document_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_document_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `full_update_document`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_document`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `full_update_document`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `full_update_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Document',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_folder(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_folder(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.full_update_folder_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_folder_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def full_update_folder_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_folder_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_folder" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `full_update_folder`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_folder`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `full_update_folder`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `full_update_folder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Folder',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_project(self, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_project(id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.full_update_project_with_http_info(id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_project_with_http_info(id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def full_update_project_with_http_info(self, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_project_with_http_info(id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_project`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `full_update_project`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `full_update_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Project',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def full_update_project_user(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_project_user(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.full_update_project_user_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.full_update_project_user_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def full_update_project_user_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """full_update_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.full_update_project_user_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method full_update_project_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `full_update_project_user`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `full_update_project_user`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `full_update_project_user`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `full_update_project_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user/{id}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FosUserWrite',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classification(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_classification(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_classification_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classification_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_classification_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_classification_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classification" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_classification`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_classification`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_classification`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Classification',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_classifications(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_classifications  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_classifications(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Classification]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_classifications_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_classifications_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_classifications_with_http_info(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_classifications  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_classifications_with_http_info(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Classification]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_classifications" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_classifications`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_classifications`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Classification]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_document(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_document(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_document_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_document_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_document_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_document_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_document`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_document`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Document',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_documents(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_documents  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_documents(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Document]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_documents_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_documents_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_documents_with_http_info(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_documents  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_documents_with_http_info(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Document]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_documents" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_documents`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_documents`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Document]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_folder(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_folder(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_folder_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_folder_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_folder_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_folder_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_folder" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_folder`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_folder`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_folder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Folder',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_folders(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_folders  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_folders(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Folder]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_folders_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_folders_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_folders_with_http_info(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_folders  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_folders_with_http_info(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[Folder]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_folders" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_folders`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_folders`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Folder]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_project(self, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_project_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_project_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_project_with_http_info(self, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_with_http_info(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_project`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Project',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_project_tree(self, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project_tree  # noqa: E501

        Returns the document tree from root folder  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_tree(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_project_tree_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_project_tree_with_http_info(id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_project_tree_with_http_info(self, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project_tree  # noqa: E501

        Returns the document tree from root folder  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_tree_with_http_info(id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_tree" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_project_tree`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_project_tree`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{id}/tree', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Folder',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_project_user(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_user(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: FosUser
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_project_user_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_project_user_with_http_info(project_pk, id, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_project_user_with_http_info(self, project_pk, id, cloud_pk, **kwargs):  # noqa: E501
        """get_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_user_with_http_info(project_pk, id, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :return: FosUser
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_project_user`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_project_user`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_project_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user/{id}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FosUser',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_project_users(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_project_users  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_users(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[FosUser]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_project_users_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_project_users_with_http_info(project_pk, cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_project_users_with_http_info(self, project_pk, cloud_pk, **kwargs):  # noqa: E501
        """get_project_users  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_project_users_with_http_info(project_pk, cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str cloud_pk: (required)
        :return: list[FosUser]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_project_users" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `get_project_users`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_project_users`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[FosUser]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_projects(self, cloud_pk, **kwargs):  # noqa: E501
        """get_projects  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_projects(cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str cloud_pk: (required)
        :return: list[Project]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.get_projects_with_http_info(cloud_pk, **kwargs)  # noqa: E501
        else:
            (data) = self.get_projects_with_http_info(cloud_pk, **kwargs)  # noqa: E501
            return data

    def get_projects_with_http_info(self, cloud_pk, **kwargs):  # noqa: E501
        """get_projects  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.get_projects_with_http_info(cloud_pk, async=True)
        >>> result = thread.get()

        :param async bool
        :param str cloud_pk: (required)
        :return: list[Project]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['cloud_pk']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_projects" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `get_projects`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[Project]',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_classification(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_classification(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Classification data: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_classification_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.update_classification_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def update_classification_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_classification  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_classification_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Classification data: (required)
        :return: Classification
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_classification" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `update_classification`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_classification`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `update_classification`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `update_classification`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/classification/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Classification',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_document(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_document(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_document_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.update_document_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def update_document_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_document  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_document_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Document data: (required)
        :return: Document
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `update_document`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_document`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `update_document`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `update_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/document/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Document',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_folder(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_folder(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_folder_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.update_folder_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def update_folder_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_folder  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_folder_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Folder data: (required)
        :return: Folder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_folder" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `update_folder`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_folder`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `update_folder`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `update_folder`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/folder/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Folder',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_project(self, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_project(id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_project_with_http_info(id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.update_project_with_http_info(id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def update_project_with_http_info(self, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_project  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_project_with_http_info(id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str id: (required)
        :param str cloud_pk: (required)
        :param Project data: (required)
        :return: Project
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_project" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_project`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `update_project`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `update_project`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Project',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_project_user(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_project_user(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async'):
            return self.update_project_user_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
        else:
            (data) = self.update_project_user_with_http_info(project_pk, id, cloud_pk, data, **kwargs)  # noqa: E501
            return data

    def update_project_user_with_http_info(self, project_pk, id, cloud_pk, data, **kwargs):  # noqa: E501
        """update_project_user  # noqa: E501

          # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async=True
        >>> thread = api.update_project_user_with_http_info(project_pk, id, cloud_pk, data, async=True)
        >>> result = thread.get()

        :param async bool
        :param str project_pk: (required)
        :param str id: (required)
        :param str cloud_pk: (required)
        :param FosUserWrite data: (required)
        :return: FosUserWrite
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['project_pk', 'id', 'cloud_pk', 'data']  # noqa: E501
        all_params.append('async')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_project_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'project_pk' is set
        if ('project_pk' not in params or
                params['project_pk'] is None):
            raise ValueError("Missing the required parameter `project_pk` when calling `update_project_user`")  # noqa: E501
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `update_project_user`")  # noqa: E501
        # verify the required parameter 'cloud_pk' is set
        if ('cloud_pk' not in params or
                params['cloud_pk'] is None):
            raise ValueError("Missing the required parameter `cloud_pk` when calling `update_project_user`")  # noqa: E501
        # verify the required parameter 'data' is set
        if ('data' not in params or
                params['data'] is None):
            raise ValueError("Missing the required parameter `data` when calling `update_project_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'project_pk' in params:
            path_params['project_pk'] = params['project_pk']  # noqa: E501
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501
        if 'cloud_pk' in params:
            path_params['cloud_pk'] = params['cloud_pk']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'data' in params:
            body_params = params['data']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/cloud/{cloud_pk}/project/{project_pk}/user/{id}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FosUserWrite',  # noqa: E501
            auth_settings=auth_settings,
            async=params.get('async'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
